from typing import Any

import gspread
import pandas as pd

from strideutils.stride_config import get_env_or_raise as get_env_or_raise

SCOPES: tuple[str, str, str]

class GoogleSheetsClient:
    client: gspread.Client
    cache_enabled: bool
    def __new__(cls) -> GoogleSheetsClient: ...
    def __init__(self, cache_enabled: bool = False) -> None: ...
    def grab_sheet(self, sheet_id: str, sheet_name: str, columns_labeled: bool = True) -> pd.DataFrame: ...
    def write_sheet(self, df: pd.DataFrame, sheet_id: str, sheet_name: str) -> None: ...
    def write_cell(self, value: list[list[Any]], range_name: str, sheet_id: str, sheet_name: str) -> None: ...
    def reorder_sheet(self, sheet_id: str, sheet_name: str, new_location: int = 0) -> None: ...
    def get_sheet_names(self, sheet_id: str) -> list[str]: ...
